<html>
<head>
<title>OGRE: OgreVector3.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreVector3.h</h1><a href="OgreVector3_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Vector3_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Vector3_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreMath_8h.html">OgreMath.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00046"></a><a class="code" href="classOgre_1_1Vector3.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">public</span>:
<a name="l00049"></a><a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">00049</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, y, z;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a><a class="code" href="classOgre_1_1Vector3.html#b75a79e6126d060995368fe8647418eb">00052</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>()
<a name="l00053"></a>00053         {
<a name="l00054"></a>00054         }
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classOgre_1_1Vector3.html#64c48c8b902431103b9e9d7a372cedd7">00056</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fZ )
<a name="l00057"></a>00057             : x( fX ), y( fY ), z( fZ )
<a name="l00058"></a>00058         {
<a name="l00059"></a>00059         }
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classOgre_1_1Vector3.html#faa92dd5ee9762c5461cb6d7916f6d55">00061</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afCoordinate[3] )
<a name="l00062"></a>00062             : x( afCoordinate[0] ),
<a name="l00063"></a>00063               y( afCoordinate[1] ),
<a name="l00064"></a>00064               z( afCoordinate[2] )
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066         }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classOgre_1_1Vector3.html#c3c34be918e6bea663404c5364dad048">00068</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <span class="keywordtype">int</span> afCoordinate[3] )
<a name="l00069"></a>00069         {
<a name="l00070"></a>00070             x = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[0];
<a name="l00071"></a>00071             y = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[1];
<a name="l00072"></a>00072             z = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[2];
<a name="l00073"></a>00073         }
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classOgre_1_1Vector3.html#6c55bec7491f10ea8c661d82daa602b0">00075</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* <span class="keyword">const</span> r )
<a name="l00076"></a>00076             : x( r[0] ), y( r[1] ), z( r[2] )
<a name="l00077"></a>00077         {
<a name="l00078"></a>00078         }
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classOgre_1_1Vector3.html#84db6b6e0412f7a2e91e50649d6d9794">00080</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scaler )
<a name="l00081"></a>00081             : x( scaler )
<a name="l00082"></a>00082             , y( scaler )
<a name="l00083"></a>00083             , z( scaler )
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085         }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classOgre_1_1Vector3.html#9bd50aebc79eddd7ff980d3816cbea5e">00088</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00089"></a>00089             : x( rkVector.x ), y( rkVector.y ), z( rkVector.z )
<a name="l00090"></a>00090         {
<a name="l00091"></a>00091         }
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classOgre_1_1Vector3.html#776848af1b3d4d74b9e54ec8de046b36">00093</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00094"></a>00094 <span class="keyword">        </span>{
<a name="l00095"></a>00095             assert( i &lt; 3 );
<a name="l00096"></a>00096 
<a name="l00097"></a>00097             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00098"></a>00098         }
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classOgre_1_1Vector3.html#b5a34a541047cf3b7aa223d77ee8f126">00100</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00101"></a>00101         {
<a name="l00102"></a>00102             assert( i &lt; 3 );
<a name="l00103"></a>00103 
<a name="l00104"></a>00104             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00105"></a>00105         }
<a name="l00107"></a><a class="code" href="classOgre_1_1Vector3.html#7952f09744c63b5230ba4ea4b2c2d00a">00107</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00108"></a>00108         {
<a name="l00109"></a>00109             <span class="keywordflow">return</span> &amp;x;
<a name="l00110"></a>00110         }
<a name="l00112"></a><a class="code" href="classOgre_1_1Vector3.html#4fc4943ff293f3b78f7e0f6602e67657">00112</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00113"></a>00113 <span class="keyword">        </span>{
<a name="l00114"></a>00114             <span class="keywordflow">return</span> &amp;x;
<a name="l00115"></a>00115         }
<a name="l00116"></a>00116 
<a name="l00121"></a><a class="code" href="classOgre_1_1Vector3.html#b5de4a9f833c4427a3b2105fcd6f96ad">00121</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00122"></a>00122         {
<a name="l00123"></a>00123             x = rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00124"></a>00124             y = rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00125"></a>00125             z = rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classOgre_1_1Vector3.html#554fbfe97d222e9e7669faf168104f06">00130</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScaler )
<a name="l00131"></a>00131         {
<a name="l00132"></a>00132             x = fScaler;
<a name="l00133"></a>00133             y = fScaler;
<a name="l00134"></a>00134             z = fScaler;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00137"></a>00137         }
<a name="l00138"></a>00138 
<a name="l00139"></a><a class="code" href="classOgre_1_1Vector3.html#4911c81b5674a51a267f672d94519bd7">00139</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00140"></a>00140 <span class="keyword">        </span>{
<a name="l00141"></a>00141             <span class="keywordflow">return</span> ( x == rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; y == rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; z == rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> );
<a name="l00142"></a>00142         }
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classOgre_1_1Vector3.html#6912f6690162a822f5606daef1345588">00144</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#9d8174300d9fd7b766d727c85e11a20f">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00145"></a>00145 <span class="keyword">        </span>{
<a name="l00146"></a>00146             <span class="keywordflow">return</span> ( x != rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> || y != rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> || z != rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> );
<a name="l00147"></a>00147         }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149         <span class="comment">// arithmetic operations</span>
<a name="l00150"></a><a class="code" href="classOgre_1_1Vector3.html#f382b37682a172c036d1141083aeb351">00150</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator + ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00151"></a>00151 <span class="keyword">        </span>{
<a name="l00152"></a>00152             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00153"></a>00153                 x + rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00154"></a>00154                 y + rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00155"></a>00155                 z + rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classOgre_1_1Vector3.html#b9a92534cc5b9799ea749ff9fb4f63af">00158</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00159"></a>00159 <span class="keyword">        </span>{
<a name="l00160"></a>00160             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00161"></a>00161                 x - rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00162"></a>00162                 y - rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00163"></a>00163                 z - rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00164"></a>00164         }
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="classOgre_1_1Vector3.html#a5da201689c5ebb6c721b3458aae6efa">00166</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00167"></a>00167 <span class="keyword">        </span>{
<a name="l00168"></a>00168             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00169"></a>00169                 x * fScalar,
<a name="l00170"></a>00170                 y * fScalar,
<a name="l00171"></a>00171                 z * fScalar);
<a name="l00172"></a>00172         }
<a name="l00173"></a>00173 
<a name="l00174"></a><a class="code" href="classOgre_1_1Vector3.html#38f29443aab585b9ad32d6e99d78165b">00174</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00175"></a>00175 <span class="keyword">        </span>{
<a name="l00176"></a>00176             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00177"></a>00177                 x * rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00178"></a>00178                 y * rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00179"></a>00179                 z * rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00180"></a>00180         }
<a name="l00181"></a>00181 
<a name="l00182"></a><a class="code" href="classOgre_1_1Vector3.html#c3c3bfa100cfa73e20523b8ab569626d">00182</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00183"></a>00183 <span class="keyword">        </span>{
<a name="l00184"></a>00184             assert( fScalar != 0.0 );
<a name="l00185"></a>00185 
<a name="l00186"></a>00186             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0 / fScalar;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00189"></a>00189                 x * fInv,
<a name="l00190"></a>00190                 y * fInv,
<a name="l00191"></a>00191                 z * fInv);
<a name="l00192"></a>00192         }
<a name="l00193"></a>00193 
<a name="l00194"></a><a class="code" href="classOgre_1_1Vector3.html#1a3b1399fe72dd39eba3ca78c5efe491">00194</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00195"></a>00195 <span class="keyword">        </span>{
<a name="l00196"></a>00196             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00197"></a>00197                 x / rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00198"></a>00198                 y / rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00199"></a>00199                 z / rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00200"></a>00200         }
<a name="l00201"></a>00201 
<a name="l00202"></a><a class="code" href="classOgre_1_1Vector3.html#d6f60ae56629526dc89c1f725297d403">00202</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator + ()<span class="keyword"> const</span>
<a name="l00203"></a>00203 <span class="keyword">        </span>{
<a name="l00204"></a>00204             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00205"></a>00205         }
<a name="l00206"></a>00206 
<a name="l00207"></a><a class="code" href="classOgre_1_1Vector3.html#73971f7dd2342f5077509d23d277930b">00207</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - ()<span class="keyword"> const</span>
<a name="l00208"></a>00208 <span class="keyword">        </span>{
<a name="l00209"></a>00209             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(-x, -y, -z);
<a name="l00210"></a>00210         }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212         <span class="comment">// overloaded operators to help Vector3</span>
<a name="l00213"></a><a class="code" href="classOgre_1_1Vector3.html#03fe1c87e6e667cebeaa6ffd391461ea">00213</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00214"></a>00214         {
<a name="l00215"></a>00215             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00216"></a>00216                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00217"></a>00217                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00218"></a>00218                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00219"></a>00219         }
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classOgre_1_1Vector3.html#3505ef8e8c296ad49bdbe837185fa0e2">00221</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00222"></a>00222         {
<a name="l00223"></a>00223             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00224"></a>00224                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00225"></a>00225                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00226"></a>00226                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00227"></a>00227         }
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classOgre_1_1Vector3.html#09fc339aca944e8b0bb21d02215a092e">00229</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator + (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00230"></a>00230         {
<a name="l00231"></a>00231             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00232"></a>00232                 lhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> + rhs,
<a name="l00233"></a>00233                 lhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> + rhs,
<a name="l00234"></a>00234                 lhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> + rhs);
<a name="l00235"></a>00235         }
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classOgre_1_1Vector3.html#a5a711e980d3f906f83bf4740b573aaf">00237</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator + (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00238"></a>00238         {
<a name="l00239"></a>00239             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00240"></a>00240                 lhs + rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00241"></a>00241                 lhs + rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00242"></a>00242                 lhs + rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00243"></a>00243         }
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="classOgre_1_1Vector3.html#2c6a217a917e372153a225a53fd5b99f">00245</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00246"></a>00246         {
<a name="l00247"></a>00247             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00248"></a>00248                 lhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> - rhs,
<a name="l00249"></a>00249                 lhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> - rhs,
<a name="l00250"></a>00250                 lhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> - rhs);
<a name="l00251"></a>00251         }
<a name="l00252"></a>00252 
<a name="l00253"></a><a class="code" href="classOgre_1_1Vector3.html#eca31428e2157b9a26380b3a7eec482e">00253</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00254"></a>00254         {
<a name="l00255"></a>00255             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00256"></a>00256                 lhs - rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00257"></a>00257                 lhs - rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00258"></a>00258                 lhs - rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00259"></a>00259         }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261         <span class="comment">// arithmetic updates</span>
<a name="l00262"></a><a class="code" href="classOgre_1_1Vector3.html#e3ac60e2c77755046f6a00f09f54793a">00262</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00263"></a>00263         {
<a name="l00264"></a>00264             x += rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00265"></a>00265             y += rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00266"></a>00266             z += rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00269"></a>00269         }
<a name="l00270"></a>00270 
<a name="l00271"></a><a class="code" href="classOgre_1_1Vector3.html#1ee74f38b762d0d0a5bf961268a74a74">00271</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00272"></a>00272         {
<a name="l00273"></a>00273             x += fScalar;
<a name="l00274"></a>00274             y += fScalar;
<a name="l00275"></a>00275             z += fScalar;
<a name="l00276"></a>00276             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00277"></a>00277         }
<a name="l00278"></a>00278 
<a name="l00279"></a><a class="code" href="classOgre_1_1Vector3.html#c514b9e1f5dbe855b1458a2d72a27621">00279</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00280"></a>00280         {
<a name="l00281"></a>00281             x -= rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00282"></a>00282             y -= rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00283"></a>00283             z -= rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00286"></a>00286         }
<a name="l00287"></a>00287 
<a name="l00288"></a><a class="code" href="classOgre_1_1Vector3.html#db8b9ff11371c1b011f8d46c36c54d40">00288</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00289"></a>00289         {
<a name="l00290"></a>00290             x -= fScalar;
<a name="l00291"></a>00291             y -= fScalar;
<a name="l00292"></a>00292             z -= fScalar;
<a name="l00293"></a>00293             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00294"></a>00294         }
<a name="l00295"></a>00295 
<a name="l00296"></a><a class="code" href="classOgre_1_1Vector3.html#73ff015725314ef25bab902bf27cd4e6">00296</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00297"></a>00297         {
<a name="l00298"></a>00298             x *= fScalar;
<a name="l00299"></a>00299             y *= fScalar;
<a name="l00300"></a>00300             z *= fScalar;
<a name="l00301"></a>00301             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00302"></a>00302         }
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classOgre_1_1Vector3.html#bc4a2427d36b11da17f8674bb6bdbc3f">00304</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00305"></a>00305         {
<a name="l00306"></a>00306             x *= rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00307"></a>00307             y *= rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00308"></a>00308             z *= rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312 
<a name="l00313"></a><a class="code" href="classOgre_1_1Vector3.html#fd733cc4140ba78de2427b8fa9951e12">00313</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00314"></a>00314         {
<a name="l00315"></a>00315             assert( fScalar != 0.0 );
<a name="l00316"></a>00316 
<a name="l00317"></a>00317             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0 / fScalar;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319             x *= fInv;
<a name="l00320"></a>00320             y *= fInv;
<a name="l00321"></a>00321             z *= fInv;
<a name="l00322"></a>00322 
<a name="l00323"></a>00323             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00324"></a>00324         }
<a name="l00325"></a>00325 
<a name="l00326"></a><a class="code" href="classOgre_1_1Vector3.html#d8b5fad0c40ae5dd087bbade10b8403e">00326</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00327"></a>00327         {
<a name="l00328"></a>00328             x /= rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00329"></a>00329             y /= rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00330"></a>00330             z /= rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00331"></a>00331 
<a name="l00332"></a>00332             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00333"></a>00333         }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00343"></a><a class="code" href="classOgre_1_1Vector3.html#af4b62c1fe4d51e3a49b76490900d843">00343</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length ()<span class="keyword"> const</span>
<a name="l00344"></a>00344 <span class="keyword">        </span>{
<a name="l00345"></a>00345             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#b1ee8b71699ce68bd8cf91113ead793e">Math::Sqrt</a>( x * x + y * y + z * z );
<a name="l00346"></a>00346         }
<a name="l00347"></a>00347 
<a name="l00358"></a><a class="code" href="classOgre_1_1Vector3.html#d465ee0d92aaa5e760b835b8f0db711d">00358</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredLength ()<span class="keyword"> const</span>
<a name="l00359"></a>00359 <span class="keyword">        </span>{
<a name="l00360"></a>00360             <span class="keywordflow">return</span> x * x + y * y + z * z;
<a name="l00361"></a>00361         }
<a name="l00362"></a>00362 
<a name="l00370"></a><a class="code" href="classOgre_1_1Vector3.html#146a420f1319626829627482b83ead38">00370</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00371"></a>00371 <span class="keyword">        </span>{
<a name="l00372"></a>00372             <span class="keywordflow">return</span> (*<span class="keyword">this</span> - rhs).length();
<a name="l00373"></a>00373         }
<a name="l00374"></a>00374 
<a name="l00385"></a><a class="code" href="classOgre_1_1Vector3.html#4417057512532ff59fc2c980a3c8a599">00385</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00386"></a>00386 <span class="keyword">        </span>{
<a name="l00387"></a>00387             <span class="keywordflow">return</span> (*<span class="keyword">this</span> - rhs).squaredLength();
<a name="l00388"></a>00388         }
<a name="l00389"></a>00389 
<a name="l00404"></a><a class="code" href="classOgre_1_1Vector3.html#a4063f05819fcb3d1bef754718608976">00404</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00405"></a>00405 <span class="keyword">        </span>{
<a name="l00406"></a>00406             <span class="keywordflow">return</span> x * vec.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> + y * vec.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> + z * vec.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00407"></a>00407         }
<a name="l00408"></a>00408 
<a name="l00419"></a><a class="code" href="classOgre_1_1Vector3.html#8572c00ede9c7d6db9e4f885b3d4476e">00419</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> absDotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00420"></a>00420 <span class="keyword">        </span>{
<a name="l00421"></a>00421             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#e9e2434f05aed3c19b600af6b48c59b7">Math::Abs</a>(x * vec.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>) + <a class="code" href="classOgre_1_1Math.html#e9e2434f05aed3c19b600af6b48c59b7">Math::Abs</a>(y * vec.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>) + <a class="code" href="classOgre_1_1Math.html#e9e2434f05aed3c19b600af6b48c59b7">Math::Abs</a>(z * vec.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00422"></a>00422         }
<a name="l00423"></a>00423 
<a name="l00433"></a><a class="code" href="classOgre_1_1Vector3.html#9e572a5cc4e1ed826839e5281d8f1d3b">00433</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise()
<a name="l00434"></a>00434         {
<a name="l00435"></a>00435             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fLength = <a class="code" href="classOgre_1_1Math.html#b1ee8b71699ce68bd8cf91113ead793e">Math::Sqrt</a>( x * x + y * y + z * z );
<a name="l00436"></a>00436 
<a name="l00437"></a>00437             <span class="comment">// Will also work for zero-sized vectors, but will change nothing</span>
<a name="l00438"></a>00438             <span class="keywordflow">if</span> ( fLength &gt; 1e-08 )
<a name="l00439"></a>00439             {
<a name="l00440"></a>00440                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInvLength = 1.0 / fLength;
<a name="l00441"></a>00441                 x *= fInvLength;
<a name="l00442"></a>00442                 y *= fInvLength;
<a name="l00443"></a>00443                 z *= fInvLength;
<a name="l00444"></a>00444             }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446             <span class="keywordflow">return</span> fLength;
<a name="l00447"></a>00447         }
<a name="l00448"></a>00448 
<a name="l00477"></a><a class="code" href="classOgre_1_1Vector3.html#22832c010c733fcdd4f3ac7daa99a006">00477</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> crossProduct( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00478"></a>00478 <span class="keyword">        </span>{
<a name="l00479"></a>00479             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00480"></a>00480                 y * rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> - z * rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00481"></a>00481                 z * rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> - x * rkVector.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>,
<a name="l00482"></a>00482                 x * rkVector.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> - y * rkVector.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>);
<a name="l00483"></a>00483         }
<a name="l00484"></a>00484 
<a name="l00488"></a><a class="code" href="classOgre_1_1Vector3.html#3c770ca212fb3b84f6668c96a2b67ae2">00488</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> midPoint( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec )<span class="keyword"> const</span>
<a name="l00489"></a>00489 <span class="keyword">        </span>{
<a name="l00490"></a>00490             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00491"></a>00491                 ( x + vec.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> ) * 0.5,
<a name="l00492"></a>00492                 ( y + vec.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> ) * 0.5,
<a name="l00493"></a>00493                 ( z + vec.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> ) * 0.5 );
<a name="l00494"></a>00494         }
<a name="l00495"></a>00495 
<a name="l00499"></a><a class="code" href="classOgre_1_1Vector3.html#f84d6701735b0c5f0a0f1534ef5ed46c">00499</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator &lt; ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00500"></a>00500 <span class="keyword">        </span>{
<a name="l00501"></a>00501             <span class="keywordflow">if</span>( x &lt; rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; y &lt; rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; z &lt; rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> )
<a name="l00502"></a>00502                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00503"></a>00503             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00504"></a>00504         }
<a name="l00505"></a>00505 
<a name="l00509"></a><a class="code" href="classOgre_1_1Vector3.html#17134a53241f0ccdecc851616f2c6464">00509</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator &gt; ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00510"></a>00510 <span class="keyword">        </span>{
<a name="l00511"></a>00511             <span class="keywordflow">if</span>( x &gt; rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; y &gt; rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; z &gt; rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> )
<a name="l00512"></a>00512                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00513"></a>00513             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00514"></a>00514         }
<a name="l00515"></a>00515 
<a name="l00523"></a><a class="code" href="classOgre_1_1Vector3.html#8430bb9f7756acb8256497f004afac49">00523</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeFloor( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; cmp )
<a name="l00524"></a>00524         {
<a name="l00525"></a>00525             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00526"></a>00526             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00527"></a>00527             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt; z ) z = cmp.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00528"></a>00528         }
<a name="l00529"></a>00529 
<a name="l00537"></a><a class="code" href="classOgre_1_1Vector3.html#61e91dcf16f7db52d299e976526218e3">00537</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeCeil( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; cmp )
<a name="l00538"></a>00538         {
<a name="l00539"></a>00539             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> &gt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00540"></a>00540             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> &gt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00541"></a>00541             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> &gt; z ) z = cmp.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00542"></a>00542         }
<a name="l00543"></a>00543 
<a name="l00551"></a><a class="code" href="classOgre_1_1Vector3.html#f654ef1e00ba82ca63695336b81da153">00551</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> perpendicular(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00552"></a>00552 <span class="keyword">        </span>{
<a name="l00553"></a>00553             <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fSquareZero = 1e-06 * 1e-06;
<a name="l00554"></a>00554 
<a name="l00555"></a>00555             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> perp = this-&gt;crossProduct( <a class="code" href="classOgre_1_1Vector3.html#0c21d1f120c5eab83aa966e5de1df311">Vector3::UNIT_X</a> );
<a name="l00556"></a>00556 
<a name="l00557"></a>00557             <span class="comment">// Check length</span>
<a name="l00558"></a>00558             <span class="keywordflow">if</span>( perp.<a class="code" href="classOgre_1_1Vector3.html#d465ee0d92aaa5e760b835b8f0db711d" title="Returns the square of the length(magnitude) of the vector.">squaredLength</a>() &lt; fSquareZero )
<a name="l00559"></a>00559             {
<a name="l00560"></a>00560                 <span class="comment">/* This vector is the Y axis multiplied by a scalar, so we have</span>
<a name="l00561"></a>00561 <span class="comment">                   to use another axis.</span>
<a name="l00562"></a>00562 <span class="comment">                */</span>
<a name="l00563"></a>00563                 perp = this-&gt;crossProduct( <a class="code" href="classOgre_1_1Vector3.html#8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a> );
<a name="l00564"></a>00564             }
<a name="l00565"></a>00565             perp.<a class="code" href="classOgre_1_1Vector3.html#9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00566"></a>00566 
<a name="l00567"></a>00567             <span class="keywordflow">return</span> perp;
<a name="l00568"></a>00568         }
<a name="l00588"></a><a class="code" href="classOgre_1_1Vector3.html#371428dc4de1c24544746973637fc7a9">00588</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> randomDeviant(
<a name="l00589"></a>00589             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle,
<a name="l00590"></a>00590             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; up = <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a> )<span class="keyword"> const</span>
<a name="l00591"></a>00591 <span class="keyword">        </span>{
<a name="l00592"></a>00592             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> newUp;
<a name="l00593"></a>00593 
<a name="l00594"></a>00594             <span class="keywordflow">if</span> (up == <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>)
<a name="l00595"></a>00595             {
<a name="l00596"></a>00596                 <span class="comment">// Generate an up vector</span>
<a name="l00597"></a>00597                 newUp = this-&gt;perpendicular();
<a name="l00598"></a>00598             }
<a name="l00599"></a>00599             <span class="keywordflow">else</span>
<a name="l00600"></a>00600             {
<a name="l00601"></a>00601                 newUp = up;
<a name="l00602"></a>00602             }
<a name="l00603"></a>00603 
<a name="l00604"></a>00604             <span class="comment">// Rotate up vector by random amount around this</span>
<a name="l00605"></a>00605             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> q;
<a name="l00606"></a>00606             q.<a class="code" href="classOgre_1_1Quaternion.html#c3328c1bb86d17e870c57d52720e2e32">FromAngleAxis</a>( <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>(<a class="code" href="classOgre_1_1Math.html#17da3bb870f8654628d6f429a144aea1">Math::UnitRandom</a>() * <a class="code" href="classOgre_1_1Math.html#58d139439316e19e9142000f1a6bdf6d">Math::TWO_PI</a>), *<span class="keyword">this</span> );
<a name="l00607"></a>00607             newUp = q * newUp;
<a name="l00608"></a>00608 
<a name="l00609"></a>00609             <span class="comment">// Finally rotate this by given angle around randomised up</span>
<a name="l00610"></a>00610             q.<a class="code" href="classOgre_1_1Quaternion.html#c3328c1bb86d17e870c57d52720e2e32">FromAngleAxis</a>( angle, newUp );
<a name="l00611"></a>00611             <span class="keywordflow">return</span> q * (*this);
<a name="l00612"></a>00612         }
<a name="l00613"></a>00613 <span class="preprocessor">#ifndef OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00614"></a>00614 <span class="preprocessor"></span>        <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> randomDeviant(
<a name="l00615"></a>00615             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> angle,
<a name="l00616"></a>00616             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; up = <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a> )<span class="keyword"> const</span>
<a name="l00617"></a>00617 <span class="keyword">        </span>{
<a name="l00618"></a>00618             <span class="keywordflow">return</span> randomDeviant ( <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>(angle), up );
<a name="l00619"></a>00619         }
<a name="l00620"></a>00620 <span class="preprocessor">#endif//OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00621"></a>00621 <span class="preprocessor"></span>
<a name="l00630"></a><a class="code" href="classOgre_1_1Vector3.html#eeef4472ad0c4d5f34a038a9f2faa819">00630</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> getRotationTo(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dest,
<a name="l00631"></a>00631             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; fallbackAxis = <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>)<span class="keyword"> const</span>
<a name="l00632"></a>00632 <span class="keyword">        </span>{
<a name="l00633"></a>00633             <span class="comment">// Based on Stan Melax's article in Game Programming Gems</span>
<a name="l00634"></a>00634             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> q;
<a name="l00635"></a>00635             <span class="comment">// Copy, since cannot modify local</span>
<a name="l00636"></a>00636             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> v0 = *<span class="keyword">this</span>;
<a name="l00637"></a>00637             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> v1 = dest;
<a name="l00638"></a>00638             v0.<a class="code" href="classOgre_1_1Vector3.html#9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00639"></a>00639             v1.<a class="code" href="classOgre_1_1Vector3.html#9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00640"></a>00640 
<a name="l00641"></a>00641             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> d = v0.<a class="code" href="classOgre_1_1Vector3.html#a4063f05819fcb3d1bef754718608976" title="Calculates the dot (scalar) product of this vector with another.">dotProduct</a>(v1);
<a name="l00642"></a>00642             <span class="comment">// If dot == 1, vectors are the same</span>
<a name="l00643"></a>00643             <span class="keywordflow">if</span> (d &gt;= 1.0f)
<a name="l00644"></a>00644             {
<a name="l00645"></a>00645                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Quaternion.html#441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>;
<a name="l00646"></a>00646             }
<a name="l00647"></a>00647             <span class="keywordflow">if</span> (d &lt; (1e-6f - 1.0f))
<a name="l00648"></a>00648             {
<a name="l00649"></a>00649                 <span class="keywordflow">if</span> (fallbackAxis != <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>)
<a name="l00650"></a>00650                 {
<a name="l00651"></a>00651                     <span class="comment">// rotate 180 degrees about the fallback axis</span>
<a name="l00652"></a>00652                     q.<a class="code" href="classOgre_1_1Quaternion.html#c3328c1bb86d17e870c57d52720e2e32">FromAngleAxis</a>(<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>(<a class="code" href="classOgre_1_1Math.html#ee3e908f569f6d83d8359ef0d88a0461">Math::PI</a>), fallbackAxis);
<a name="l00653"></a>00653                 }
<a name="l00654"></a>00654                 <span class="keywordflow">else</span>
<a name="l00655"></a>00655                 {
<a name="l00656"></a>00656                     <span class="comment">// Generate an axis</span>
<a name="l00657"></a>00657                     <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> axis = <a class="code" href="classOgre_1_1Vector3.html#0c21d1f120c5eab83aa966e5de1df311">Vector3::UNIT_X</a>.<a class="code" href="classOgre_1_1Vector3.html#22832c010c733fcdd4f3ac7daa99a006" title="Calculates the cross-product of 2 vectors, i.e.">crossProduct</a>(*<span class="keyword">this</span>);
<a name="l00658"></a>00658                     <span class="keywordflow">if</span> (axis.<a class="code" href="classOgre_1_1Vector3.html#6fb95c613736dbf41a6b193547cc8fee" title="Returns true if this vector is zero length.">isZeroLength</a>()) <span class="comment">// pick another if colinear</span>
<a name="l00659"></a>00659                         axis = <a class="code" href="classOgre_1_1Vector3.html#8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a>.crossProduct(*<span class="keyword">this</span>);
<a name="l00660"></a>00660                     axis.<a class="code" href="classOgre_1_1Vector3.html#9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00661"></a>00661                     q.<a class="code" href="classOgre_1_1Quaternion.html#c3328c1bb86d17e870c57d52720e2e32">FromAngleAxis</a>(<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>(<a class="code" href="classOgre_1_1Math.html#ee3e908f569f6d83d8359ef0d88a0461">Math::PI</a>), axis);
<a name="l00662"></a>00662                 }
<a name="l00663"></a>00663             }
<a name="l00664"></a>00664             <span class="keywordflow">else</span>
<a name="l00665"></a>00665             {
<a name="l00666"></a>00666                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> s = <a class="code" href="classOgre_1_1Math.html#b1ee8b71699ce68bd8cf91113ead793e">Math::Sqrt</a>( (1+d)*2 );
<a name="l00667"></a>00667                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> invs = 1 / s;
<a name="l00668"></a>00668 
<a name="l00669"></a>00669                 <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> c = v0.<a class="code" href="classOgre_1_1Vector3.html#22832c010c733fcdd4f3ac7daa99a006" title="Calculates the cross-product of 2 vectors, i.e.">crossProduct</a>(v1);
<a name="l00670"></a>00670 
<a name="l00671"></a>00671                 q.<a class="code" href="classOgre_1_1Quaternion.html#32c5680516b41bc4ba3159bf4d4abaf1">x</a> = c.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a> * invs;
<a name="l00672"></a>00672                 q.<a class="code" href="classOgre_1_1Quaternion.html#a7328cd3883a92ee9c9322805d038f11">y</a> = c.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a> * invs;
<a name="l00673"></a>00673                 q.<a class="code" href="classOgre_1_1Quaternion.html#31ec84a931236554c0c17e37bf5ace97">z</a> = c.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a> * invs;
<a name="l00674"></a>00674                 q.<a class="code" href="classOgre_1_1Quaternion.html#f3424f1e07092c0ffe293d18b277a04f">w</a> = s * 0.5;
<a name="l00675"></a>00675                 q.<a class="code" href="classOgre_1_1Quaternion.html#ee94ec9c7de50fe7f774ae4c7e760b65" title="Normalises this quaternion, and returns the previous length.">normalise</a>();
<a name="l00676"></a>00676             }
<a name="l00677"></a>00677             <span class="keywordflow">return</span> q;
<a name="l00678"></a>00678         }
<a name="l00679"></a>00679 
<a name="l00681"></a><a class="code" href="classOgre_1_1Vector3.html#6fb95c613736dbf41a6b193547cc8fee">00681</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isZeroLength(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00682"></a>00682 <span class="keyword">        </span>{
<a name="l00683"></a>00683             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sqlen = (x * x) + (y * y) + (z * z);
<a name="l00684"></a>00684             <span class="keywordflow">return</span> (sqlen &lt; (1e-06 * 1e-06));
<a name="l00685"></a>00685 
<a name="l00686"></a>00686         }
<a name="l00687"></a>00687 
<a name="l00690"></a><a class="code" href="classOgre_1_1Vector3.html#50bec7fc9389d530ed6caac9b74bae7b">00690</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> normalisedCopy(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00691"></a>00691 <span class="keyword">        </span>{
<a name="l00692"></a>00692             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> ret = *<span class="keyword">this</span>;
<a name="l00693"></a>00693             ret.<a class="code" href="classOgre_1_1Vector3.html#9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00694"></a>00694             <span class="keywordflow">return</span> ret;
<a name="l00695"></a>00695         }
<a name="l00696"></a>00696 
<a name="l00700"></a><a class="code" href="classOgre_1_1Vector3.html#2bf94b1c0ac1fa59c16dc6e1bff39f9c">00700</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> reflect(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; normal)<span class="keyword"> const</span>
<a name="l00701"></a>00701 <span class="keyword">        </span>{
<a name="l00702"></a>00702             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( *<span class="keyword">this</span> - ( 2 * this-&gt;dotProduct(normal) * normal ) );
<a name="l00703"></a>00703         }
<a name="l00704"></a>00704 
<a name="l00711"></a><a class="code" href="classOgre_1_1Vector3.html#824cd193cc75dd39ccc74bad0cc7182d">00711</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> positionEquals(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> tolerance = 1e-03)<span class="keyword"> const</span>
<a name="l00712"></a>00712 <span class="keyword">        </span>{
<a name="l00713"></a>00713             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(x, rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>, tolerance) &amp;&amp;
<a name="l00714"></a>00714                 <a class="code" href="classOgre_1_1Math.html#890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(y, rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>, tolerance) &amp;&amp;
<a name="l00715"></a>00715                 <a class="code" href="classOgre_1_1Math.html#890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(z, rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>, tolerance);
<a name="l00716"></a>00716 
<a name="l00717"></a>00717         }
<a name="l00718"></a>00718 
<a name="l00725"></a><a class="code" href="classOgre_1_1Vector3.html#b0b7a22e68461036f00179ae909193f4">00725</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> positionCloses(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> tolerance = 1e-03f)<span class="keyword"> const</span>
<a name="l00726"></a>00726 <span class="keyword">        </span>{
<a name="l00727"></a>00727             <span class="keywordflow">return</span> squaredDistance(rhs) &lt;=
<a name="l00728"></a>00728                 (squaredLength() + rhs.<a class="code" href="classOgre_1_1Vector3.html#d465ee0d92aaa5e760b835b8f0db711d" title="Returns the square of the length(magnitude) of the vector.">squaredLength</a>()) * tolerance;
<a name="l00729"></a>00729         }
<a name="l00730"></a>00730 
<a name="l00738"></a><a class="code" href="classOgre_1_1Vector3.html#97208398c491c8b3f68de8e8c0c3b789">00738</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> directionEquals(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs,
<a name="l00739"></a>00739             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; tolerance)<span class="keyword"> const</span>
<a name="l00740"></a>00740 <span class="keyword">        </span>{
<a name="l00741"></a>00741             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dot = dotProduct(rhs);
<a name="l00742"></a>00742             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> angle = <a class="code" href="classOgre_1_1Math.html#53869f3197b0f991aea7f5edf6b620e2">Math::ACos</a>(dot);
<a name="l00743"></a>00743 
<a name="l00744"></a>00744             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#e9e2434f05aed3c19b600af6b48c59b7">Math::Abs</a>(angle.<a class="code" href="classOgre_1_1Radian.html#e48b00b9345103217741b497108848d2">valueRadians</a>()) &lt;= tolerance.<a class="code" href="classOgre_1_1Radian.html#e48b00b9345103217741b497108848d2">valueRadians</a>();
<a name="l00745"></a>00745 
<a name="l00746"></a>00746         }
<a name="l00747"></a>00747 
<a name="l00748"></a>00748         <span class="comment">// special points</span>
<a name="l00749"></a><a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">00749</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> ZERO;
<a name="l00750"></a><a class="code" href="classOgre_1_1Vector3.html#0c21d1f120c5eab83aa966e5de1df311">00750</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> UNIT_X;
<a name="l00751"></a><a class="code" href="classOgre_1_1Vector3.html#8d1a1f7af535bcc8d9c78b1732bc1b90">00751</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> UNIT_Y;
<a name="l00752"></a><a class="code" href="classOgre_1_1Vector3.html#d25aed2e9367cfa879d3e3c231c5a136">00752</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> UNIT_Z;
<a name="l00753"></a><a class="code" href="classOgre_1_1Vector3.html#46e43c65e6da1ff630652694a966d63c">00753</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> NEGATIVE_UNIT_X;
<a name="l00754"></a><a class="code" href="classOgre_1_1Vector3.html#6b674c303fc2ade68ce2fd6ae74b8c11">00754</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> NEGATIVE_UNIT_Y;
<a name="l00755"></a><a class="code" href="classOgre_1_1Vector3.html#bdeebea4e94e114215a51831f9792f19">00755</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> NEGATIVE_UNIT_Z;
<a name="l00756"></a><a class="code" href="classOgre_1_1Vector3.html#6a27e8a3a9156701f586afeed1516fb8">00756</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> UNIT_SCALE;
<a name="l00757"></a>00757 
<a name="l00760"></a>00760         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00761"></a><a class="code" href="classOgre_1_1Vector3.html#64adb4b87769f63f900fef109e4c4f3b">00761</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v )
<a name="l00762"></a>00762         {
<a name="l00763"></a>00763             o &lt;&lt; <span class="stringliteral">"Vector3("</span> &lt;&lt; v.x &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; v.y &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; v.z &lt;&lt; <span class="stringliteral">")"</span>;
<a name="l00764"></a>00764             <span class="keywordflow">return</span> o;
<a name="l00765"></a>00765         }
<a name="l00766"></a>00766     };
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 }
<a name="l00769"></a>00769 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
